<?php
/**
 * Description of Pogoda
 * 
 * NOWA POGODA:
 * http://www.worldweatheronline.com/feed-generater.aspx
 * API KEY: 224923fd18123834112111
 *
 * @author alfred
 * @author pZ - poprawki dla Dąbrowy Górniczej
 */
class Pogoda {
    public static function saveToDatabase (SimpleXMLElement $xml) {
        $xml_text = $xml->asXML();
        $id_portalu = sfConfig::get('portal')->getId();
        $kom = KomunikatPeer::retrieveByPK("pogo_xml", $id_portalu);
        if (!$kom) {
            $kom = new Komunikat();
            $kom->setNazwa('pogo_xml');
            $kom->setPortal(sfConfig::get('portal'));
        }
        $kom->setTresc($xml_text);     
        $kom->save();

        UstawieniePeer::setProperties('pogo',array('time'=>time()));
    }

    public static function loadFromDatabase () {
        $id_portalu = sfConfig::get('portal')->getId();
        $kom = KomunikatPeer::retrieveByPK('pogo_xml', $id_portalu);

        if ($kom) $xml_text = $kom->getTresc();

        if (isset($xml_text)&&$xml_text) {
            $xml = @simplexml_load_string($xml_text);
        }
        else {
            return false;
        }

        return $xml;
    }

    public static function retrieveFromServer ($lokalizacja,$dni,$jednostka) {
      
//        $xml_remote = @file_get_contents('http://xoap.weather.com/weather/local/'.$lokalizacja.'?cc=*&dayf='.$dni.'&unit='.$jednostka.'&link=xoap&prod=xoap&par=1135131527&key=cb0ecbcdb7455de3');

        // pZ: nowy serwis pogodowy
        // używam urlencode() bo ta funkcja zamienia spacje na +
        // D%c4%85browa+G%c3%b3rnicza,Polska
        $xml_remote = @file_get_contents('http://api.worldweatheronline.com/free/v2/weather.ashx?q='.urlencode($lokalizacja).'&format=xml&num_of_days='.$dni.'&key=8emjn88hpw2uxqyq6h792sw6&lang=pl');

        $xml = simplexml_load_string($xml_remote);

        return $xml;
    }

    public static function readFromFile () {
        $xml_file = sfConfig::get('sf_upload_dir').'/pogoda.xml';
        $exists = file_exists($xml_file);

        if ($exists) {
            $xml_text = file_get_contents($xml_file);
            $xml = simplexml_load_string($xml_text);
        }
        else {
            return false;
        }
        return $xml;
    }
}
