<?php

class pogodaComponents extends sfComponents {
    /**
     * Komponent odpowiedzialny za date, imieniny, pogode
     */
    public function executeDataImieninyPogoda() {
        $c_imieniny = new Criteria();
        $c_imieniny->add(ImieninyPeer::DZIEN, date("j"));
        $c_imieniny->add(ImieninyPeer::MIESIAC, date("n"));
        $this->imieniny = ImieninyPeer::doSelectOne($c_imieniny);

        if (in_array('pogo', ModulPeer::getEnabled())) {
            $this->dni_tygodnia = array(1 => 'Poniedziałek', 2 => 'Wtorek', 3 => 'Środa', 4 => 'Czwartek', 5 => 'Piątek', 6 => 'Sobota', 7 => 'Niedziela');
            $this->miesiace = array(1 => 'stycznia', 2 => 'lutego', 3 => 'marca', 4 => 'kwietnia', 5 => 'maja', 6 => 'czerwca', 7 => 'lipca', 8 => 'sierpnia', 9 => 'września', 10 => 'października', 11 => 'listopada', 12 => 'grudnia');
        }
    }

    /*
     * $dni		- pogoda na ile dni [od 1 do 5]
     * $lokalizacja 	- kod miejscowości
     * $jednostka	- jednostki miary [s = standardowe  m = metryczne]
     * $icons		- wymiary grafik [od 1 do 3]
     *
     * pZ: UWAGA!! - JUZ JEST OBSLUGA NOWEJ POGODY - ALE TEN COMPONENT DZIALA BEZ ZMIAN !
     */

    public static function execPogoda($dni = 3, $lokalizacja = 'PLXX0022', $jednostka = 'm', $size = 2) {
        $text = '';
        $baza = false;

        $pogo_time = UstawieniePeer::getProperties('pogo', true);
        (int) $update_time = (isset($pogo_time['time']) && $pogo_time['time']) ? $pogo_time['time'] + (60 * 60 * 2) : 0;

        $time = time();

        $xml = false;
        //$source = '';
        // Pogoda nie aktualna w bazie
        if ($update_time < $time) {
            // Sprawdzamy serwer
            $xml = Pogoda::retrieveFromServer($lokalizacja, $dni, $jednostka);
            $source = 'server';
        }

        if (!$xml) {
            // Czytamy z bazy
            $xml = Pogoda::loadFromDatabase();
            $source = 'database';
        }

        if (!$xml) {
            // Sprawdzamy serwer
            $xml = Pogoda::retrieveFromServer($lokalizacja, $dni, $jednostka);
            $source = 'server';
        }

        if (!$xml) {
            // Czytamy plik
            $xml = Pogoda::readFromFile();
            $source = 'file';
        }

        if ($xml && $source != 'database') {
            // Zapisujemy do bazy
            Pogoda::saveToDatabase($xml);
        }

        // Wszystkie opcje wyczerpane
        if (!$xml) {
            return false;
        }
        return $xml;
    }
}
?>
