<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * DanePogodowe filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseDanePogodoweFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'delay'        => new sfWidgetFormFilterInput(),
      'hum_in'       => new sfWidgetFormFilterInput(),
      'temp_in'      => new sfWidgetFormFilterInput(),
      'hum_out'      => new sfWidgetFormFilterInput(),
      'temp_out'     => new sfWidgetFormFilterInput(),
      'abs_pressure' => new sfWidgetFormFilterInput(),
      'wind_ave'     => new sfWidgetFormFilterInput(),
      'wind_gust'    => new sfWidgetFormFilterInput(),
      'wind_dir'     => new sfWidgetFormFilterInput(),
      'rain'         => new sfWidgetFormFilterInput(),
      'status'       => new sfWidgetFormFilterInput(),
    ));

    $this->setValidators(array(
      'delay'        => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'hum_in'       => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'temp_in'      => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'hum_out'      => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'temp_out'     => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'abs_pressure' => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'wind_ave'     => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'wind_gust'    => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'wind_dir'     => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'rain'         => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
      'status'       => new sfValidatorSchemaFilter('text', new sfValidatorNumber(array('required' => false))),
    ));

    $this->widgetSchema->setNameFormat('dane_pogodowe_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'DanePogodowe';
  }

  public function getFields()
  {
    return array(
      'date'         => 'Date',
      'delay'        => 'Number',
      'hum_in'       => 'Number',
      'temp_in'      => 'Number',
      'hum_out'      => 'Number',
      'temp_out'     => 'Number',
      'abs_pressure' => 'Number',
      'wind_ave'     => 'Number',
      'wind_gust'    => 'Number',
      'wind_dir'     => 'Number',
      'rain'         => 'Number',
      'status'       => 'Number',
    );
  }
}
