<?php



class DanePogodoweMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.DanePogodoweMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(DanePogodowePeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(DanePogodowePeer::TABLE_NAME);
		$tMap->setPhpName('DanePogodowe');
		$tMap->setClassname('DanePogodowe');

		$tMap->setUseIdGenerator(false);

		$tMap->addPrimaryKey('DATE', 'Date', 'TIMESTAMP', true, null);

		$tMap->addColumn('DELAY', 'Delay', 'DECIMAL', false, 10);

		$tMap->addColumn('HUM_IN', 'HumIn', 'DECIMAL', false, 10);

		$tMap->addColumn('TEMP_IN', 'TempIn', 'DECIMAL', false, 10);

		$tMap->addColumn('HUM_OUT', 'HumOut', 'DECIMAL', false, 10);

		$tMap->addColumn('TEMP_OUT', 'TempOut', 'DECIMAL', false, 10);

		$tMap->addColumn('ABS_PRESSURE', 'AbsPressure', 'DECIMAL', false, 10);

		$tMap->addColumn('WIND_AVE', 'WindAve', 'DECIMAL', false, 10);

		$tMap->addColumn('WIND_GUST', 'WindGust', 'DECIMAL', false, 10);

		$tMap->addColumn('WIND_DIR', 'WindDir', 'DECIMAL', false, 10);

		$tMap->addColumn('RAIN', 'Rain', 'DECIMAL', false, 10);

		$tMap->addColumn('STATUS', 'Status', 'DECIMAL', false, 10);

	} 
} 