<?php


abstract class BaseDanePogodowe extends BaseObject  implements Persistent {


  const PEER = 'DanePogodowePeer';

	
	protected static $peer;

	
	protected $date;

	
	protected $delay;

	
	protected $hum_in;

	
	protected $temp_in;

	
	protected $hum_out;

	
	protected $temp_out;

	
	protected $abs_pressure;

	
	protected $wind_ave;

	
	protected $wind_gust;

	
	protected $wind_dir;

	
	protected $rain;

	
	protected $status;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getDate($format = 'Y-m-d H:i:s')
	{
		if ($this->date === null) {
			return null;
		}


		if ($this->date === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->date);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->date, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getDelay()
	{
		return $this->delay;
	}

	
	public function getHumIn()
	{
		return $this->hum_in;
	}

	
	public function getTempIn()
	{
		return $this->temp_in;
	}

	
	public function getHumOut()
	{
		return $this->hum_out;
	}

	
	public function getTempOut()
	{
		return $this->temp_out;
	}

	
	public function getAbsPressure()
	{
		return $this->abs_pressure;
	}

	
	public function getWindAve()
	{
		return $this->wind_ave;
	}

	
	public function getWindGust()
	{
		return $this->wind_gust;
	}

	
	public function getWindDir()
	{
		return $this->wind_dir;
	}

	
	public function getRain()
	{
		return $this->rain;
	}

	
	public function getStatus()
	{
		return $this->status;
	}

	
	public function setDate($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->date !== null || $dt !== null ) {
			
			$currNorm = ($this->date !== null && $tmpDt = new DateTime($this->date)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->date = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = DanePogodowePeer::DATE;
			}
		} 
		return $this;
	} 
	
	public function setDelay($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->delay !== $v) {
			$this->delay = $v;
			$this->modifiedColumns[] = DanePogodowePeer::DELAY;
		}

		return $this;
	} 
	
	public function setHumIn($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->hum_in !== $v) {
			$this->hum_in = $v;
			$this->modifiedColumns[] = DanePogodowePeer::HUM_IN;
		}

		return $this;
	} 
	
	public function setTempIn($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->temp_in !== $v) {
			$this->temp_in = $v;
			$this->modifiedColumns[] = DanePogodowePeer::TEMP_IN;
		}

		return $this;
	} 
	
	public function setHumOut($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->hum_out !== $v) {
			$this->hum_out = $v;
			$this->modifiedColumns[] = DanePogodowePeer::HUM_OUT;
		}

		return $this;
	} 
	
	public function setTempOut($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->temp_out !== $v) {
			$this->temp_out = $v;
			$this->modifiedColumns[] = DanePogodowePeer::TEMP_OUT;
		}

		return $this;
	} 
	
	public function setAbsPressure($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->abs_pressure !== $v) {
			$this->abs_pressure = $v;
			$this->modifiedColumns[] = DanePogodowePeer::ABS_PRESSURE;
		}

		return $this;
	} 
	
	public function setWindAve($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wind_ave !== $v) {
			$this->wind_ave = $v;
			$this->modifiedColumns[] = DanePogodowePeer::WIND_AVE;
		}

		return $this;
	} 
	
	public function setWindGust($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wind_gust !== $v) {
			$this->wind_gust = $v;
			$this->modifiedColumns[] = DanePogodowePeer::WIND_GUST;
		}

		return $this;
	} 
	
	public function setWindDir($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wind_dir !== $v) {
			$this->wind_dir = $v;
			$this->modifiedColumns[] = DanePogodowePeer::WIND_DIR;
		}

		return $this;
	} 
	
	public function setRain($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->rain !== $v) {
			$this->rain = $v;
			$this->modifiedColumns[] = DanePogodowePeer::RAIN;
		}

		return $this;
	} 
	
	public function setStatus($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->status !== $v) {
			$this->status = $v;
			$this->modifiedColumns[] = DanePogodowePeer::STATUS;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->date = ($row[$startcol + 0] !== null) ? (string) $row[$startcol + 0] : null;
			$this->delay = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->hum_in = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->temp_in = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->hum_out = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->temp_out = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->abs_pressure = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->wind_ave = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->wind_gust = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->wind_dir = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->rain = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->status = ($row[$startcol + 11] !== null) ? (string) $row[$startcol + 11] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 12; 
		} catch (Exception $e) {
			throw new PropelException("Error populating DanePogodowe object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DanePogodowePeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = DanePogodowePeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DanePogodowePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			DanePogodowePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DanePogodowePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			DanePogodowePeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = DanePogodowePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += DanePogodowePeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = DanePogodowePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = DanePogodowePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getDate();
				break;
			case 1:
				return $this->getDelay();
				break;
			case 2:
				return $this->getHumIn();
				break;
			case 3:
				return $this->getTempIn();
				break;
			case 4:
				return $this->getHumOut();
				break;
			case 5:
				return $this->getTempOut();
				break;
			case 6:
				return $this->getAbsPressure();
				break;
			case 7:
				return $this->getWindAve();
				break;
			case 8:
				return $this->getWindGust();
				break;
			case 9:
				return $this->getWindDir();
				break;
			case 10:
				return $this->getRain();
				break;
			case 11:
				return $this->getStatus();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = DanePogodowePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getDate(),
			$keys[1] => $this->getDelay(),
			$keys[2] => $this->getHumIn(),
			$keys[3] => $this->getTempIn(),
			$keys[4] => $this->getHumOut(),
			$keys[5] => $this->getTempOut(),
			$keys[6] => $this->getAbsPressure(),
			$keys[7] => $this->getWindAve(),
			$keys[8] => $this->getWindGust(),
			$keys[9] => $this->getWindDir(),
			$keys[10] => $this->getRain(),
			$keys[11] => $this->getStatus(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = DanePogodowePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setDate($value);
				break;
			case 1:
				$this->setDelay($value);
				break;
			case 2:
				$this->setHumIn($value);
				break;
			case 3:
				$this->setTempIn($value);
				break;
			case 4:
				$this->setHumOut($value);
				break;
			case 5:
				$this->setTempOut($value);
				break;
			case 6:
				$this->setAbsPressure($value);
				break;
			case 7:
				$this->setWindAve($value);
				break;
			case 8:
				$this->setWindGust($value);
				break;
			case 9:
				$this->setWindDir($value);
				break;
			case 10:
				$this->setRain($value);
				break;
			case 11:
				$this->setStatus($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = DanePogodowePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setDate($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDelay($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setHumIn($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setTempIn($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setHumOut($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTempOut($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setAbsPressure($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setWindAve($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setWindGust($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setWindDir($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setRain($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setStatus($arr[$keys[11]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(DanePogodowePeer::DATABASE_NAME);

		if ($this->isColumnModified(DanePogodowePeer::DATE)) $criteria->add(DanePogodowePeer::DATE, $this->date);
		if ($this->isColumnModified(DanePogodowePeer::DELAY)) $criteria->add(DanePogodowePeer::DELAY, $this->delay);
		if ($this->isColumnModified(DanePogodowePeer::HUM_IN)) $criteria->add(DanePogodowePeer::HUM_IN, $this->hum_in);
		if ($this->isColumnModified(DanePogodowePeer::TEMP_IN)) $criteria->add(DanePogodowePeer::TEMP_IN, $this->temp_in);
		if ($this->isColumnModified(DanePogodowePeer::HUM_OUT)) $criteria->add(DanePogodowePeer::HUM_OUT, $this->hum_out);
		if ($this->isColumnModified(DanePogodowePeer::TEMP_OUT)) $criteria->add(DanePogodowePeer::TEMP_OUT, $this->temp_out);
		if ($this->isColumnModified(DanePogodowePeer::ABS_PRESSURE)) $criteria->add(DanePogodowePeer::ABS_PRESSURE, $this->abs_pressure);
		if ($this->isColumnModified(DanePogodowePeer::WIND_AVE)) $criteria->add(DanePogodowePeer::WIND_AVE, $this->wind_ave);
		if ($this->isColumnModified(DanePogodowePeer::WIND_GUST)) $criteria->add(DanePogodowePeer::WIND_GUST, $this->wind_gust);
		if ($this->isColumnModified(DanePogodowePeer::WIND_DIR)) $criteria->add(DanePogodowePeer::WIND_DIR, $this->wind_dir);
		if ($this->isColumnModified(DanePogodowePeer::RAIN)) $criteria->add(DanePogodowePeer::RAIN, $this->rain);
		if ($this->isColumnModified(DanePogodowePeer::STATUS)) $criteria->add(DanePogodowePeer::STATUS, $this->status);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(DanePogodowePeer::DATABASE_NAME);

		$criteria->add(DanePogodowePeer::DATE, $this->date);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getDate();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setDate($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDate($this->date);

		$copyObj->setDelay($this->delay);

		$copyObj->setHumIn($this->hum_in);

		$copyObj->setTempIn($this->temp_in);

		$copyObj->setHumOut($this->hum_out);

		$copyObj->setTempOut($this->temp_out);

		$copyObj->setAbsPressure($this->abs_pressure);

		$copyObj->setWindAve($this->wind_ave);

		$copyObj->setWindGust($this->wind_gust);

		$copyObj->setWindDir($this->wind_dir);

		$copyObj->setRain($this->rain);

		$copyObj->setStatus($this->status);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new DanePogodowePeer();
		}
		return self::$peer;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
	}

} 