<?php


abstract class BaseImieniny extends BaseObject  implements Persistent {


  const PEER = 'ImieninyPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $dzien;

	
	protected $miesiac;

	
	protected $imiona;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->dzien = 0;
		$this->miesiac = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getDzien()
	{
		return $this->dzien;
	}

	
	public function getMiesiac()
	{
		return $this->miesiac;
	}

	
	public function getImiona()
	{
		return $this->imiona;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ImieninyPeer::ID;
		}

		return $this;
	} 
	
	public function setDzien($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->dzien !== $v || $v === 0) {
			$this->dzien = $v;
			$this->modifiedColumns[] = ImieninyPeer::DZIEN;
		}

		return $this;
	} 
	
	public function setMiesiac($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->miesiac !== $v || $v === 0) {
			$this->miesiac = $v;
			$this->modifiedColumns[] = ImieninyPeer::MIESIAC;
		}

		return $this;
	} 
	
	public function setImiona($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->imiona !== $v) {
			$this->imiona = $v;
			$this->modifiedColumns[] = ImieninyPeer::IMIONA;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(ImieninyPeer::DZIEN,ImieninyPeer::MIESIAC))) {
				return false;
			}

			if ($this->dzien !== 0) {
				return false;
			}

			if ($this->miesiac !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->dzien = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->miesiac = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->imiona = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Imieniny object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ImieninyPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = ImieninyPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ImieninyPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			ImieninyPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ImieninyPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			ImieninyPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = ImieninyPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ImieninyPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ImieninyPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ImieninyPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ImieninyPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDzien();
				break;
			case 2:
				return $this->getMiesiac();
				break;
			case 3:
				return $this->getImiona();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = ImieninyPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDzien(),
			$keys[2] => $this->getMiesiac(),
			$keys[3] => $this->getImiona(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ImieninyPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDzien($value);
				break;
			case 2:
				$this->setMiesiac($value);
				break;
			case 3:
				$this->setImiona($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ImieninyPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDzien($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setMiesiac($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setImiona($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ImieninyPeer::DATABASE_NAME);

		if ($this->isColumnModified(ImieninyPeer::ID)) $criteria->add(ImieninyPeer::ID, $this->id);
		if ($this->isColumnModified(ImieninyPeer::DZIEN)) $criteria->add(ImieninyPeer::DZIEN, $this->dzien);
		if ($this->isColumnModified(ImieninyPeer::MIESIAC)) $criteria->add(ImieninyPeer::MIESIAC, $this->miesiac);
		if ($this->isColumnModified(ImieninyPeer::IMIONA)) $criteria->add(ImieninyPeer::IMIONA, $this->imiona);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ImieninyPeer::DATABASE_NAME);

		$criteria->add(ImieninyPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDzien($this->dzien);

		$copyObj->setMiesiac($this->miesiac);

		$copyObj->setImiona($this->imiona);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ImieninyPeer();
		}
		return self::$peer;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
	}

} 